// *F* Developed 2011-2014 rejecht <rejecht at outlook dot com>

class AMBot extends ReBot
	HideDropdown
	;

// #PawnClass

event SetPawnClass
(
    string BotPawnClassNameString,
    string BotCharacterNameString
)
{
    local Class<AMPawn> LoadedPawnClass;

    LoadedPawnClass = Class<AMPawn>(DynamicLoadObject (BotPawnClassNameString, Class'Core.Class'));

    if (LoadedPawnClass != None)
    {
        PawnClass = LoadedPawnClass;
    }

    PawnSetupRecord = Class'XGame.xUtil'.Static.FindPlayerRecord (BotCharacterNameString);

    PlayerReplicationInfo.SetCharacterName (BotCharacterNameString);
}

// - Reminder: AMPlayer must have the same logic.

event AwardAdrenaline (float Amount)
{
	if (bAdrenalineEnabled)
	{
		if
		(
			(
				ReGRI(Level.GRI).IsRestarting () // Ignore punishment at end of round..
				&&
				(Amount <= 0.0f) // ..but accept rewards.
			)
			||
			(
				!ReGRI(Level.GRI).bTeamCombos // Do not reward/punish if team combos are disabled..
				&&
				(Pawn != None)
				&&
				Pawn.InCurrentCombo () // ..and player is in a combo.
			)
		)
		{
			return; // Reminder: No stats logged.
		}
    }


	Super.AwardAdrenaline (Amount);
}

// #

DefaultProperties
{
	// Matches xPlayer.ComboNameList

    ComboNames(0) = "XGame.ComboSpeed"
    ComboNames(1) = "Re.AMComboBerserk" // Freon/TAM
    ComboNames(2) = "XGame.ComboDefensive"
    ComboNames(3) = "XGame.ComboInvis"

	// Controller

	PawnClass = Class'AMPawn'
	PlayerReplicationInfoClass = Class'RePRI'
}
