// *F* Developed 2014 rejecht <rejecht at outlook dot com>

class LocalMessage_AwardBroadcast extends CriticalEventPlus
	abstract
	config (User)
	;

var(Colors) GlobalConfig Color
	DarkHorseColor,
	HeadhunterColor,
	RetributionColor;

var(ConstantStrings) private localized const string
	DarkHorseStringPrefix,
	DarkHorseStringSuffix,
	HeadhunterStringPrefix,
	HeadhunterStringSuffix,
	RetributionStringPrefix,
	RetributionString,
	RetributionStringSuffix;

// #Queries

static event string GetString
(
	optional int AwardIndex,
	optional PlayerReplicationInfo RelatedPRI_1,
	optional PlayerReplicationInfo RelatedPRI_2,
	optional Object O
)
{
	switch (AwardIndex)
	{
		case 0:
			return
			(
				Default.DarkHorseStringPrefix
				$ Class'ReUtility'.Static.GetPlayerNameString (RelatedPRI_1)
				$ Default.DarkHorseStringSuffix
			);

		case 1:
			return
			(
				Default.RetributionStringPrefix
				$ Class'ReUtility'.Static.GetPlayerNameString (RelatedPRI_1)
				$ Default.RetributionString
				$ Class'ReUtility'.Static.GetPlayerNameString (RelatedPRI_2)
				$ Default.RetributionStringSuffix
			);

		case 3:
			return
			(
				Default.HeadhunterStringPrefix
				$ Class'ReUtility'.Static.GetPlayerNameString (RelatedPRI_1)
				$ Default.HeadhunterStringSuffix
			);
	}

	return "";
}

// #

static event Color GetColor
(
	optional int AwardIndex,
	optional PlayerReplicationInfo RelatedPRI_1,
	optional PlayerReplicationInfo RelatedPRI_2
)
{
	switch (AwardIndex)
	{
		case 0:
			return Default.DarkHorseColor;

		case 1:
			return Default.RetributionColor;

		case 3:
			return Default.HeadhunterColor;
	}


	return Default.DrawColor;
}

// #

protected static function PlayAnnouncement
(
	PlayerController PC,
	optional int AwardIndex,
	optional PlayerReplicationInfo RelatedPRI_1,
	optional PlayerReplicationInfo RelatedPRI_2,
	optional Object O
)
{
	switch (AwardIndex)
	{
		case 0:
			UnrealPlayer(PC).ClientDelayedAnnouncement (Sound'Sounds.DarkHorse', 18);
			break;
	}
}

// #Dispatch

static event ClientReceive
(
	PlayerController PC,
	optional int AwardIndex,
	optional PlayerReplicationInfo RelatedPRI_1,
	optional PlayerReplicationInfo RelatedPRI_2,
	optional Object O
)
{
	PlayAnnouncement (PC, AwardIndex, RelatedPRI_1, RelatedPRI_2, O);


	Super.ClientReceive (PC, AwardIndex, RelatedPRI_1, RelatedPRI_2, O);
}

// #

DefaultProperties
{
	DarkHorseStringSuffix = " IS A DARK HORSE"
	DarkHorseColor = (R=78,G=0,B=234,A=255)

	HeadhunterStringSuffix = " IS A HEADHUNTER"
	HeadhunterColor = (R=0,G=160,B=255,A=223)

	RetributionString = " got retribution on "
	RetributionColor = (R=0,G=160,B=255,A=223)

	// LocalMessage

	bIsConsoleMessage = False
	bIsSpecial = True

	bIsUnique = False
	bIsPartiallyUnique = True

	FontSize = 0

	PosY = 0.675

	StackMode = SM_Up
}
