// *F* Developed 2014 rejecht <rejecht at outlook dot com>

class LocalMessage_AwardLocal extends CriticalEventPlus
	abstract
	;

// #Queries

static event string GetString
(
	optional int AwardIndex,
	optional PlayerReplicationInfo RelatedPRI_1,
	optional PlayerReplicationInfo RelatedPRI_2,
	optional Object O
)
{
	return Class<Award>(O).Static.GetCaptionString (AwardIndex);
}

// Assumes all indices are passed to Award_Event.

static event int GetFontSize
(
	int IgnoredAwardIndex,
	PlayerReplicationInfo RelatedPRI_1,
	PlayerReplicationInfo RelatedPRI_2,
	PlayerReplicationInfo LocalPlayer
)
{
	if
	(
		(LocalPlayer != None)
		&&
		(ReGRI(LocalPlayer.Level.GRI) != None)
		&&
		(
			ReGRI(LocalPlayer.Level.GRI).IsRestarting ()
			||
			ReGRI(LocalPlayer.Level.GRI).IsOver ()
		)
	)
	{
		return Clamp (Class'PlayerSettings'.Default.AwardFontSize + 3, -8, 8);
	}
	else
	{
		return Clamp (Class'PlayerSettings'.Default.AwardFontSize, -8, 8);
	}
}

// Assumes all indices are passed to Award_Event.

static event float GetLifeTime (int IgnoredAwardIndex)
{
	return Clamp (Class'PlayerSettings'.Default.AwardLifetime, 0, 60);
}

// Assumes all indices are passed to Award_Event.

static event Color GetColor
(
	optional int IgnoredAwardIndex,
	optional PlayerReplicationInfo RelatedPRI_1,
	optional PlayerReplicationInfo RelatedPRI_2
)
{
	return Class'PlayerSettings'.Default.AwardDrawColor;
}

// Allow player to mess around with drawing position and style.

static event GetPos
(
	int Switch,
	out EDrawPivot Out_DrawPivot,
	out EStackMode Out_StackMode,
	out float Out_PosX,
	out float Out_PosY
)
{
	Out_DrawPivot = Class'PlayerSettings'.Default.AwardDrawPivot;
	Out_StackMode = Class'PlayerSettings'.Default.AwardStackMode;
	Out_PosX = Class'PlayerSettings'.Default.AwardPosX;
	Out_PosY = Class'PlayerSettings'.Default.AwardPosY;
}

// #

DefaultProperties
{
	// LocalMessage

	bIsConsoleMessage = False
	bIsSpecial = True
	bIsUnique = False

	FontSize = 1

	StackMode = SM_Down
    PosY = 0.242
}
