// *F* Developed 2014 rejecht <rejecht at outlook dot com>

class LocalMessage_BalanceTeams extends CriticalEventPlus
    abstract
    ;

var(ConstantStrings) private localized const string
	PluralBalanceTeamsString,
	SingularBalanceTeamsString;

// #Queries

static event string GetString
(
	optional int PlayerCountDifference,
	optional PlayerReplicationInfo RelatedPRI_1,
	optional PlayerReplicationInfo RelatedPRI_2,
	optional Object O
)
{
	local TeamInfo BalanceTeamInfo;

	BalanceTeamInfo = TeamInfo(O);

	if (BalanceTeamInfo != None)
	{
		if (PlayerCountDifference > 1)
		{
			return
			(
				Repl
				(
					Repl (Default.PluralBalanceTeamsString, "%Team%", BalanceTeamInfo.GetHumanReadableName ()),
					"%Count%",
					PlayerCountDifference
				)
			);
        }
        else
        {
			return
			(
				Repl (Default.SingularBalanceTeamsString, "%Team%", BalanceTeamInfo.GetHumanReadableName ())
			);
        }
    }
    else
    {
		return "";
    }
}

static event float GetLifeTime (int PlayerCountDifference)
{
    return 1.25f; // Note: LocalMessage.Lifetime is an integer.
}

// #Dispatch

static event ClientReceive
(
	PlayerController PC,
	optional int PlayerCountDifference,
	optional PlayerReplicationInfo RelatedPRI_1,
	optional PlayerReplicationInfo RelatedPRI_2,
	optional Object O
)
{
	if (Class'PlayerSettings'.Default.bShowBalanceTeams)
	{
		Super.ClientReceive (PC, PlayerCountDifference, RelatedPRI_1, RelatedPRI_2, O);
    }
}

// #

DefaultProperties
{
	PluralBalanceTeamsString = "%Team% needs %Count% more players!"
	SingularBalanceTeamsString = "%Team% needs 1 more player!"

	// LocalMessage

	bIsConsoleMessage = False
	bComplexString = False
	bFadeMessage = True
	bIsUnique = True

	DrawColor = (R=255,G=255,B=0,A=200)
	FontSize = 1
	Lifetime = 1
	PosY = 0.1
	StackMode = SM_Down
}
