// Developed 2011-2013 rejecht <rejecht at outlook dot com>

class LocalMessage_ComboBlocked extends LocalMessage
	abstract
	;

var private localized const string MessageString[8];

var Sound ComboDeniedSound;

var float ComboDeniedSoundVolume;

// #Queries

static event string GetString
(
	optional int Index,
	optional PlayerReplicationInfo RelatedPRI_1,
	optional PlayerReplicationInfo RelatedPRI_2,
	optional Object O
)
{
	local Class<Combo> ComboClass;

	ComboClass = Class<Combo>(O);

	if
	(
		(ComboClass != None)
		&&
		(ComboClass.Default.ExecMessage != "")
	)
	{
		return
		(
			class'ReUtility'.static.GetPlainString (ComboClass.Default.ExecMessage)
			@ Default.MessageString[Index]
		);
	}
	else
	{
		return Default.MessageString[Index];
    }
}

// #Dispatch

static event ClientReceive
(
	PlayerController PC,
	optional int Context,
	optional PlayerReplicationInfo RelatedPRI_1,
	optional PlayerReplicationInfo RelatedPRI_2,
	optional Object O
)
{
	PC.ClientPlaySound (default.ComboDeniedSound, true, default.ComboDeniedSoundVolume);


	Super.ClientReceive (PC, Context, RelatedPRI_1, RelatedPRI_2, O);
}

// #

DefaultProperties
{
	MessageString(0) = "Disabled (Server)"
	MessageString(1) = "Disabled (Player)"
	MessageString(2) = "Denied (Round Over)"
	MessageString(3) = "Denied (Match Over)"
	MessageString(4) = "Denied (Adrenaline Low)"
	MessageString(5) = "Denied (Adrenaline Disabled)"
	MessageString(6) = "Denied (In Combo)"
	MessageString(7) = "Denied"

	ComboDeniedSound = Sound'MenuSounds.denied1'
	ComboDeniedSoundVolume = 1.0

	// LocalMessage

	bFadeMessage = True
	bIsConsoleMessage = False
	bIsUnique = True

	DrawColor = (R=255,G=255,B=255,A=255)
	Lifetime = 3
	PosX = 0.5
	PosY = 0.15
	StackMode = SM_Down
}
