// *F* Developed 2014 rejecht <rejecht at outlook dot com>

class LocalMessage_Died extends LocalMessage
	abstract
	;

// #Rendering

static event RenderComplexMessage
(
	Canvas Canvas,
	out float XL,
	out float YL,
	optional string MessageString,
	optional int IndexSymbol,
	optional PlayerReplicationInfo RelatedPRI_1_Subject,
	optional PlayerReplicationInfo RelatedPRI_2,
	optional Object O
)
{
	if (Canvas.DrawColor.A < (Default.DrawColor.A / Default.Lifetime))
	{
		Canvas.DrawColor.A = Canvas.DrawColor.A * Default.Lifetime;
	}
	else
	{
		Canvas.DrawColor.A = Default.DrawColor.A;
	}

	Canvas.DrawText (MessageString, True);
}

// #Queries

static event string GetString
(
	optional int Context,
	optional PlayerReplicationInfo RelatedPRI_1,
	optional PlayerReplicationInfo RelatedPRI_2_Victim,
	optional Object O
)
{
	local string IgnoredKillerNameString;
	local class<DamageType> DamageTypeClass;

	DamageTypeClass = Class<DamageType>(O);

	if (DamageTypeClass != None)
	{
		return
		(
			Class'GameInfo'.Static.ParseKillMessage
			(
				IgnoredKillerNameString,
				Class'ReUtility'.Static.GetPlayerNameString (RelatedPRI_2_Victim),
				DamageTypeClass.Static.SuicideMessage (RelatedPRI_2_Victim)
			)
		);
	}
	else
	{
		return "";
	}
}

// #

DefaultProperties
{
	bComplexString = True
	bIsConsoleMessage = False

	bFadeMessage = True
	bIsUnique = True

	DrawColor = (R=16,G=255,B=16,A=200)
	FontSize = 0
	Lifetime = 4
	PosY = 0.26125
	StackMode = SM_Down
}
