// *F* Developed 2011-2014 rejecht <rejecht at outlook dot com>

class LocalMessage_Pickup_Remote extends LocalMessage_Pickup
	abstract
	;

// #

var private localized const string TakesString;

// #Queries

static event string GetString
(
	optional int Data,
	optional PlayerReplicationInfo RelatedPRI_1,
	optional PlayerReplicationInfo RelatedPRI_2_Subject,
	optional Object O
)
{
	return
	(
		Class'ReUtility'.Static.GetPlayerNameString (RelatedPRI_2_Subject)
		$ Default.TakesString
		$ GetShortPickupNameString (Class<Pickup>(O))
	);
}

static event Color GetColor
(
	optional int Context,
	optional PlayerReplicationInfo RelatedPRI_1,
	optional PlayerReplicationInfo RelatedPRI_2_Subject
)
{
	if (!Class'PlayerSettings'.Default.bTeamColoredPickupBroadcasts)
	{
		return Default.DrawColor;
    }
    else
    {
		return Class'ReUtility'.Static.GetPlayerColor (RelatedPRI_2_Subject);
    }
}

// #Dispatch

static event ClientReceive
(
	PlayerController PC,
	optional int Data,
	optional PlayerReplicationInfo RelatedPRI_1,
	optional PlayerReplicationInfo RelatedPRI_2_Subject,
	optional Object O
)
{
	if
	(
		(
			Class'PlayerSettings'.Default.bShowTeammatePickupBroadcasts
			||
			Class'PlayerSettings'.Default.bShowEnemyPickupBroadcasts
		)
		&&
		(PC.PlayerReplicationInfo != None) // Replication Delay
		&&
		(Class<Pickup>(O) != None) // Replication Delay
		&&
		(RelatedPRI_2_Subject != None) // Replication Delay
		&&
		(RelatedPRI_2_Subject.Team != None) // Replication Delay
		&&
		(
			PC.PlayerReplicationInfo.bOnlySpectator // Spectators are on no teams or both teams depending on your glass of view.
			||
			(
				(
					Class'PlayerSettings'.Default.bShowTeammatePickupBroadcasts
					&&
					(PC.PlayerReplicationInfo.Team == RelatedPRI_2_Subject.Team) // Teammate
				)
				||
				(
					Class'PlayerSettings'.Default.bShowEnemyPickupBroadcasts
					&&
					(PC.PlayerReplicationInfo.Team != RelatedPRI_2_Subject.Team) // Enemy
				)
			)
		)
	)
	{
		Super(LocalMessage).ClientReceive (PC, Data, RelatedPRI_1, RelatedPRI_2_Subject, O);
	}
}

// #

DefaultProperties
{
	TakesString = " takes "

	// LocalMessage

	bIsSpecial = True
	bComplexString = False
	bFadeMessage = True
	bIsConsoleMessage = False
	bIsUnique = False
	bIsPartiallyUnique = False

	DrawColor = (R=255,G=38,B=233,A=255)
	DrawPivot = DP_MiddleMiddle
	FontSize = 0
	Lifetime = 3

	PosX = 0.5
	PosY = 0.1
	StackMode = SM_Down
}
