// *F* Developed 2011-2014 rejecht <rejecht at outlook dot com>

class LocalMessage_TeamWonMatch extends CriticalEventPlus
    abstract
    ;

const IndexTeam_Max = 2;
const IndexTeam_A = 0;
const IndexTeam_B = 1;
const IndexTeam_Unspecified = 255;

// #Queries

static event Color GetColor
(
	optional int WinningTeamIndex,
	optional PlayerReplicationInfo RelatedPRI_1,
	optional PlayerReplicationInfo RelatedPRI_2
)
{
	local PlayerController PC;

	if
	(
		(WinningTeamIndex < IndexTeam_Max)
		&&
		(RelatedPRI_1 != None)
		&&
		(RelatedPRI_1.Level != None)
		&&
		(RelatedPRI_1.Level.GRI != None)
		&&
		(RelatedPRI_1.Level.GRI.Teams[WinningTeamIndex] != None)
	)
	{
		PC = RelatedPRI_1.Level.GetLocalPlayerController ();
	}

	if (PC != None)
	{
		return Class'PlayerSettings'.Static.GetRelativeTeamColor (PC.GetTeamNum (), WinningTeamIndex);
	}
	else
	{
		return Default.DrawColor;
	}
}

static event string GetString
(
	optional int WinningTeamIndex,
	optional PlayerReplicationInfo RelatedPRI_1,
	optional PlayerReplicationInfo RelatedPRI_2,
	optional Object O
)
{
	local TeamInfo WinningTeamInfo;

	WinningTeamInfo = TeamInfo(O);

	if (WinningTeamInfo != None)
	{
		return
		(
			Class'XInterface.HUDBase'.Default.WonMatchPrefix
			$ WinningTeamInfo.GetHumanReadableName ()
			$ Class'XInterface.HUDBase'.Default.WonMatchPostfix
		);
    }
    else
    {
		return "";
    }
}

// #

DefaultProperties
{
	// LocalMessage

	DrawColor = (R=255,G=255,B=0,A=255)
	FontSize = 2
	Lifetime = 10
	PosY = 0.1
	StackMode = SM_Down
}
