// *F* Developed 2013 rejecht <rejecht at outlook dot com>

class LocalMessage_Thawing extends LocalMessage
	abstract
	HideDropdown
	;

var private const IntBox OffsetTexture_Symbol;
var private const Material Texture_Symbol;
var private const class<LocalMessage> ThawingSoonLocalMessageClass;

// #Rendering

static event RenderComplexMessage
(
	Canvas Canvas,
	out float XL,
	out float YL,
	optional string Text,
	optional int Percentage,
	optional PlayerReplicationInfo RelatedPRI_1,
	optional PlayerReplicationInfo RelatedPRI_2,
	optional Object O
)
{
	local float V;

	Canvas.SetPos
	(
		Canvas.ClipX * 0.46875f,
		Canvas.CurY
	);

	V = Canvas.ClipX * 0.0625f;

	Canvas.DrawTile
	(
		Default.Texture_Symbol,
		V,
		V,
		Default.OffsetTexture_Symbol.X1,
		Default.OffsetTexture_Symbol.Y1,
		Default.OffsetTexture_Symbol.X2,
		Default.OffsetTexture_Symbol.Y2
	);
}

// #Queries

static event string GetString
(
	optional int Percentage,
	optional PlayerReplicationInfo RelatedPRI_1,
	optional PlayerReplicationInfo RelatedPRI_2,
	optional Object O
)
{
	return "*";
}

// #Dispatch

static event ClientReceive
(
	PlayerController PC,
	optional int Percentage,
	optional PlayerReplicationInfo RelatedPRI_1,
	optional PlayerReplicationInfo RelatedPRI_2,
	optional Object O
)
{
	if (Percentage > 0)
	{
		if (ReFreon_PRI(PC.PlayerReplicationInfo) != None)
		{
			ReFreon_PRI(PC.PlayerReplicationInfo).ThawingPawnHealth = Percentage;
		}


		if (Percentage >= 75)
		{
			if (PC.MyHUD != None)
			{
				PC.ReceiveLocalizedMessage (Default.ThawingSoonLocalMessageClass, Percentage);
			}
        }
	}
	else
	{
		Super.ClientReceive (PC, Percentage, RelatedPRI_1, RelatedPRI_2, O);
	}
}

// #

DefaultProperties
{
	ThawingSoonLocalMessageClass = Class'LocalMessage_ThawingSoon'

	Texture_Symbol = Texture'Textures.Symbols'
	OffsetTexture_Symbol = (X1=832,Y1=0,X2=64,Y2=64)

	// LocalMessage

	bComplexString = True
	bFadeMessage = True
	bIsConsoleMessage = False
	bIsUnique = True
	bIsPartiallyUnique = False

	DrawColor = (R=255,G=255,B=0,A=127)
	FontSize = 2
	Lifetime = 1
	PosX = 0.5
	PosY = 0.25
	StackMode = SM_Down
}
