// *F* Developed 2011-2014 rejecht <rejecht at outlook dot com>

class PlayerSettings extends Object
	abstract
	config(User)
	HideDropdown
	;

const IndexTeam_Max = 2;
const IndexTeam_A = 0;
const IndexTeam_B = 1;
const IndexTeam_Unspecified = 255;

var(TeammateRadar) config float
	TeammateRadarPosX,
	TeammateRadarPosY,
	TeammateRadarSize;

// #NetworkMetrics

var(Positions) config float
	PingPosX,
	PingPosY,
	PacketLossPosX,
	PacketLossPosY;

// #Award

var(Award) config EDrawPivot AwardDrawPivot;
var(Award) config int AwardFontSize, AwardLifetime;
var(Award) config float AwardPosX, AwardPosY;
var(Award) config LocalMessage.EStackMode AwardStackMode;
var(Award) config Color AwardDrawColor;

// #Colors

var(Colors) config Color
	AnnouncementColor,
	MessageColor, // Used for console messages.
	CustomPlayerColor,
	EnemyPlayerColor, // Used in non-team games.
	HeadshotDamageTypeColor,
	GeneralDamageTypeColor,
	UnknownDamageTypeColor,
	WeaponDamageTypeColor,
	ItemColor,
	PlayerTeamSayColor,
	SpectatorSayColor,
	SpectatorTeamSayColor,
	UnknownPlayerColor,
	StandardTeamColor[IndexTeam_Max], // Applies to symbols and text such as player names and messages.
	StandardTeamSkinColor[IndexTeam_Max]; // Applies to character skins.

// #Flags

var(Flags) config bool
	bShowOwnDeathMessage,
	bPickupsBumpReticle,
	bShowPlayerEvents,
	bShowPlayersLeaving,
	bShowPlayersChangingTeams,
	bShowPlayersSpectating,
	bShowBalanceTeams,
	bShowTeamCombos,
	bShowVictimDamageType,
	bDrawTeammateRadarHeightDot,
	bTeamColoredEnemyName,
	bRequestMatchStatistics,
	bTakeEndGameScreenShot,
	bShowAwardStatusAnnouncements,
	bScoreboardShowPlayerPortrait,
	bShowScoreboardSpectators,
	bShowScoreboardVersus,
	bShowEnemyStatus,
	bShowTeammateStatus,
	bAnnounceMatchPoint,
	bAnnounceRespawnsDepleted,
	bAnnounceSuddenDeath,
	bAnnounceOverkill,
	bAnnounceOvertime,
	bStatisticsShowPortraits,
	bShowTimeWarnings,
	bFiveMinuteWarning,
	bThreeMinuteWarning,
	bTwoMinuteWarning,
	bOneMinuteWarning,
	bThirtySecondWarning,
	bTwentySecondWarning,
	bTenSecondWarning,
	bFiveSecondCountdown,
	bShowDamagePoints,
	bShowLocationName,
	bShowCamperMessage,
	bShowTeammatePickupBroadcasts,
	bShowEnemyPickupBroadcasts,
	bTeamColoredPickupBroadcasts,
	bShowSpawnProtection;

var(FontSize) config int EnemyNameFontSize;


var(Sounds) const Sound LastManOut_Sound;
var(SoundVolume) config float LastManOutSoundVolume;

// #

var() config int DamagePointFontSize;

// #

var(Opacity) config byte ScoreboardOpacity;

// #

var const byte MinLocationNameOpacity;
var const byte MaxLocationNameOpacity;
var(Colors) config Color LocationNameColor;
var(Flags) config int LocationNameFontSize;
var(Position) config int LocationNamePosX, LocationNamePosY;

// #

var const int ChatMessageLifetime_Min;
var const int ChatMessageLifetime_Max;

var config int ChatMessageLifetime;

var(Flags) config bool
	bChatMessageStay,
	bChatMessageLog;

// #Characters

var(Flags) config bool
	bReplaceTeammateCharacters,
	bReplaceEnemyCharacters;

var config string
	TeammateReplacementCharacterNameString,
	EnemyReplacementCharacterNameString;

// #bShowTeamResources

var(Flags) config bool bShowTeamResources;

// #bShowNet

var(Flags) config bool bShowNet;

// #

var(Flags) config bool bShowEventBeacons;
var(Flags) config bool bShowEventBeaconDistance;
var() config int EventBeaconFontSize;

// #

var(Flags) config bool bShowPickupMessage;

var const int MinPickupMessageType;
var const int MaxPickupMessageType;

var(Flags) config int PickupMessageType; // Requires: PickupMessage_bTeamColored

// #

var() config int ShowScoreboardWaitDelay;

// 0: Unicolor: Console Color
// 1: Unicolor: Victim Team Color
// 2: Multicolor: Console Color Base + Killer Team Color + Victim Team Color
// 3: Multicolor: Console Color Base + Killer Team Color + Damage Type Color + Victim Team Color

var(Flags) config int DeathMessage_Type; // Requires: DeathMessage_bTeamColored

var(Limits) const int
	DeathMessage_Type_Min,
	DeathMessage_Type_Max;

var(Flags) config bool
	DeathMessage_bUseWeaponName,
	DeathMessage_bUseWeaponColor;

// #

var(Flags) config bool
	bShowDamageIndicators,
	bUseTrackingDamageIndicators;

// #

var(Flags) config bool bShowCombatTyping;

// #

var(Flags) config bool bUseHitSounds;
var() config float HitSoundVolume;

// #

var(Flags) config bool bShowTeammateRadar;

// #

var(Limits) const int
	MinTeamInfoRows,
	MaxTeamInfoRows;

// #

var(Flags) config bool
	bShowTeamInfo,
	bShowTeamInfoStatus,
	bShowTeamInfoCountry;

// #

var(FontSize) config int TeamInfoFontSize;

var() config int TeamInfoRows;

// #TeamNameEnemy

var(Limits) const int
	MinEnemyInfoRows,
	MaxEnemyInfoRows;

var(Flags) config bool
	bShowEnemyInfo,
	bShowEnemyInfoStatus,
	bShowEnemyInfoCountry,
	bShowTeamInfoLocation;

var(FontSize) config int EnemyInfoFontSize;

var() config int EnemyInfoRows;

// #

var() config array<string> DisabledComboString;

// #

enum ClientSkins_EBodySkinType
{
	ES_Relative, // Default: Custom Team Colors
	ES_AbsoluteStandardBright, // Red & Blue
	ES_AbsoluteStandard, // Red & Blue
	ES_Individual
};

var(Flags) config bool bUnlitCharacters;

var private config ClientSkins_EBodySkinType CustomSkinType;

var(Colors) private config Color
	CustomTeammateColor,
	CustomEnemyColor,
	CustomTeammateSkinColor,
	CustomEnemySkinColor;

var() config float ScaledCustomSkinColor;

var config byte
	CustomTeammateAmbientGlow,
	CustomEnemyAmbientGlow;

// #

static final function SetTeammateSkinColor (optional byte Red, optional byte Green, optional byte Blue)
{
	Default.CustomTeammateSkinColor.R = Clamp (Red, 0, 127);
	Default.CustomTeammateSkinColor.G = Clamp (Green, 0, 127);
	Default.CustomTeammateSkinColor.B = Clamp (Blue, 0, 127);

	StaticSaveConfig ();
}

static final function SetEnemySkinColor (optional byte Red, optional byte Green, optional byte Blue)
{
	Default.CustomEnemySkinColor.R = Clamp (Red, 0, 127);
	Default.CustomEnemySkinColor.G = Clamp (Green, 0, 127);
	Default.CustomEnemySkinColor.B = Clamp (Blue, 0, 127);

	StaticSaveConfig ();
}

static final function ResetTeammateSkinColor ()
{
	ResetConfig ("CustomTeammateSkinColor");

	StaticSaveConfig ();
}

static final function ResetEnemySkinColor ()
{
	ResetConfig ("CustomEnemySkinColor");

	StaticSaveConfig ();
}

static final function Color GetCustomTeammateSkinColor ()
{
	return Default.CustomTeammateSkinColor;
}

static final function Color GetCustomEnemySkinColor ()
{
	return Default.CustomEnemySkinColor;
}

// Preconditions:
// - (IndexTeam_Local < IndexTeam_Max)

static final function Color GetTeammateSkinColor (int IndexTeam_Local)
{
	if (UseCustomTeammateSkinColor ())
	{
		return Default.CustomTeammateSkinColor;
	}
	else
	{
		return Default.StandardTeamSkinColor[IndexTeam_Local];
	}
}

static final function bool UseCustomTeammateSkinColor ()
{
	return
	(
		(Default.CustomTeammateSkinColor.R > 0)
		||
		(Default.CustomTeammateSkinColor.G > 0)
		||
		(Default.CustomTeammateSkinColor.B > 0)
	);
}

static final function bool UseCustomEnemySkinColor ()
{
	return
	(
		(Default.CustomEnemySkinColor.R > 0)
		||
		(Default.CustomEnemySkinColor.G > 0)
		||
		(Default.CustomEnemySkinColor.B > 0)
	);
}

// Preconditions:
// - (IndexTeam_Other < IndexTeam_Max)

static final function Color ClientSkins_GetColorBody_Relative (int IndexTeam_Local, int IndexTeam_Other)
{
	if (IndexTeam_Local == IndexTeam_Unspecified)
	{
		return Default.StandardTeamSkinColor[IndexTeam_Other];
	}

	if (IndexTeam_Local == IndexTeam_Other) // Use Relative Colors
	{
		if (UseCustomTeammateSkinColor ())
		{
			return Default.CustomTeammateSkinColor; // Relative
		}
		else
		{
			return Default.StandardTeamSkinColor[IndexTeam_Other]; // Absolute (Default)
		}
	}

	if (UseCustomEnemySkinColor ()) // Enemies
	{
		return Default.CustomEnemySkinColor; // Relative (Default)
	}
	else
	{
		return Default.StandardTeamSkinColor[IndexTeam_Other]; // Absolute
	}
}

// #

static final function ShowNet ()
{
	Default.bShowNet = !Default.bShowNet;

	StaticSaveConfig ();
}

// #

static final function ShowEvents ()
{
	Default.bShowEventBeacons = !Default.bShowEventBeacons;

	StaticSaveConfig ();
}

// #

static final function ShowEventDistance ()
{
	Default.bShowEventBeaconDistance = !Default.bShowEventBeaconDistance;

	StaticSaveConfig ();
}

static final function ShowTeam ()
{
	Default.bShowTeamInfo = !Default.bShowTeamInfo;

	StaticSaveConfig ();
}

static final function ShowEnemy ()
{
	Default.bShowEnemyInfo = !Default.bShowEnemyInfo;

	StaticSaveConfig ();
}

static final function bool SetTeammateCharacter (out int Out_Code, optional string CharacterNameString)
{
	if (Len (CharacterNameString) > 0)
	{
		Default.TeammateReplacementCharacterNameString = CharacterNameString;
		Default.bReplaceTeammateCharacters = True;

		StaticSaveConfig ();
	}
	else
	{
		Default.bReplaceTeammateCharacters = False;

		StaticSaveConfig ();
	}

	return True;
}

static final function bool SetEnemyCharacter (out int Out_Code, optional string CharacterNameString)
{
	if (Len (CharacterNameString) > 0)
	{
		Default.EnemyReplacementCharacterNameString = CharacterNameString;
		Default.bReplaceEnemyCharacters = True;

		StaticSaveConfig ();
	}
	else
	{
		Default.bReplaceEnemyCharacters = False;

		StaticSaveConfig ();
	}

	return True;
}


// #Adrenaline


static final function bool DisableAdrenalineCombo (string KeyComboString)
{
	local int Count;

	if (Len (KeyComboString) != 4)
	{
		return False;
	}

	if (!IsKeyComboStringValid (KeyComboString))
	{
		return False;
	}

	if (AdrenalineComboDisabled (KeyComboString))
	{
		return True;
	}

	Count = Default.DisabledComboString.Length;
	Default.DisabledComboString.Length = Count + 1;
	Default.DisabledComboString[Count] = Caps (KeyComboString);

	StaticSaveConfig ();

	return True;
}

static final function EnableAllAdrenalineCombos ()
{
	Default.DisabledComboString.Length = 0;

	StaticSaveConfig ();
}

// - Enabling the combo only involves removing the entry from
// the list of disabled combos.
// - Since this entry may be repeated in a configuration file
// for one or the other reason, it will remove the first occurence.
// -- Repeated calls will eventually remove all occurence.

static final function EnableAdrenalineCombo (string KeyComboString)
{
	local int IndexCombo;

	if
	(
		(Len (KeyComboString) != 4)
		||
		!IsKeyComboStringValid (KeyComboString)
	)
	{
		return;
	}

	if (!GetIndexCombo (KeyComboString, IndexCombo))
	{
		return;
	}

	Default.DisabledComboString.Remove (IndexCombo, 1);

	StaticSaveConfig ();
}

// Reminder: The combo code can only consist of the {F, B, L, R} characters.

static final function bool IsKeyComboStringValid (string KeyComboString)
{
	local int IndexKey;

	if (Len (KeyComboString) != 4)
	{
		return False;
	}

	for (IndexKey = 0; IndexKey < 4; ++IndexKey)
	{
		switch (Mid (KeyComboString, IndexKey, 1))
		{
			case "F":
			case "B":
			case "L":
			case "R":
				break;

			default:
				return False;
		}
	}

	return True;
}

static final function bool GetIndexCombo (string KeyComboString, out int Out_IndexCombo)
{
	local int IndexCombo;

	for (IndexCombo = 0; IndexCombo < Default.DisabledComboString.Length; ++IndexCombo)
	{
		if (Default.DisabledComboString[IndexCombo] ~= KeyComboString)
		{
			Out_IndexCombo = IndexCombo;

			return true;
		}
	}

	return false;
}

static final function bool AdrenalineComboDisabled (string KeyComboString)
{
	local int IndexCombo;

	for (IndexCombo = 0; IndexCombo < Default.DisabledComboString.Length; ++IndexCombo)
	{
		if (Default.DisabledComboString[IndexCombo] ~= KeyComboString)
		{
			return true;
		}
	}

	return false;
}


// #Characters


static final function ClientSkins_EBodySkinType GetBodySkinColoring ()
{
	return Default.CustomSkinType;
}

static final function SetBodySkinColoring (ClientSkins_EBodySkinType BodySkinColoring)
{
	Default.CustomSkinType = BodySkinColoring;
}

// #TeamColors

static final function Color GetCustomTeammateColor (int IndexTeam)
{
	if
	(
		(Default.CustomTeammateColor.R == 0)
		&&
		(Default.CustomTeammateColor.G == 0)
		&&
		(Default.CustomTeammateColor.B == 0)
	)
	{
		return Default.StandardTeamColor[IndexTeam];
	}
	else
	{
		return Default.CustomTeammateColor;
	}
}

static final function Color GetCustomEnemyColor (int IndexTeam)
{
	if
	(
		(Default.CustomEnemyColor.R > 0)
		||
		(Default.CustomEnemyColor.G > 0)
		||
		(Default.CustomEnemyColor.B > 0)
	)
	{
		return Default.CustomEnemyColor;
	}
	else
	{
		return Default.StandardTeamColor[IndexTeam];
	}
}

// - Returns the color depending on the context of teams.
// - IndexTeam_Local is the team of the local player or IndexTeam_A if a spectator.

static final function Color GetRelativeTeamColor (int IndexTeam_Local, int IndexTeam_Other)
{
	local Color C;

	if (IndexTeam_Local == IndexTeam_Unspecified)
	{
		C = Default.StandardTeamColor[IndexTeam_Other];
		C.A = 255;

		return C;
	}
	else if (IndexTeam_Local == IndexTeam_Other)
	{
		if
		(
			(Default.CustomTeammateColor.R == 0)
			&&
			(Default.CustomTeammateColor.G == 0)
			&&
			(Default.CustomTeammateColor.B == 0)
		)
		{
			C = Default.StandardTeamColor[IndexTeam_Other];
			C.A = 255;

			return C;
		}
		else
		{
			C = Default.CustomTeammateColor;
			C.A = 255;

			return C;
		}
	}
	else if
	(
		(Default.CustomEnemyColor.R > 0)
		||
		(Default.CustomEnemyColor.G > 0)
		||
		(Default.CustomEnemyColor.B > 0)
	)
	{
		C = Default.CustomEnemyColor;
		C.A = 255;

		return C;
	}
	else
	{
		C = Default.StandardTeamColor[IndexTeam_Other];
		C.A = 255;

		return C;
	}
}

// #

static final function bool UseCustomTeammateColor ()
{
	return
	(
		(Default.CustomTeammateColor.R > 0)
		||
		(Default.CustomTeammateColor.G > 0)
		||
		(Default.CustomTeammateColor.B > 0)
	);
}

static final function bool UseCustomEnemyColor ()
{
	return
	(
		(Default.CustomEnemyColor.R > 0)
		||
		(Default.CustomEnemyColor.G > 0)
		||
		(Default.CustomEnemyColor.B > 0)
	);
}

// #SetCustom*Color

static final function SetCustomTeammateColor
(
	optional byte Red,
	optional byte Green,
	optional byte Blue
)
{
	Default.CustomTeammateColor.R = Red;
	Default.CustomTeammateColor.G = Green;
	Default.CustomTeammateColor.B = Blue;
	Default.CustomTeammateColor.A = 255;

	StaticSaveConfig ();
}

static final function SetCustomEnemyColor
(
	optional byte Red,
	optional byte Green,
	optional byte Blue
)
{
	Default.CustomEnemyColor.R = Red;
	Default.CustomEnemyColor.G = Green;
	Default.CustomEnemyColor.B = Blue;
	Default.CustomEnemyColor.A = 255;

	StaticSaveConfig ();
}

static final function SetCustomPlayerColor
(
	optional byte Red,
	optional byte Green,
	optional byte Blue
)
{
	Default.CustomPlayerColor.R = Red;
	Default.CustomPlayerColor.G = Green;
	Default.CustomPlayerColor.B = Blue;
	Default.CustomPlayerColor.A = 255;

	StaticSaveConfig ();
}

// #GetCustom*Color

static final function Color GetCurrentCustomTeammateColor ()
{
	return Default.CustomTeammateColor;
}

static final function Color GetCurrentCustomEnemyColor ()
{
	return Default.CustomEnemyColor;
}

static final function Color GetCurrentCustomPlayerColor ()
{
	return Default.CustomPlayerColor;
}

// #ResetCustom*Color

static final function ResetCustomTeammateColor ()
{
	ResetConfig ("CustomTeammateColor");

	StaticSaveConfig ();
}

static final function ResetCustomEnemyColor ()
{
	ResetConfig ("CustomEnemyColor");

	StaticSaveConfig ();
}

static final function ResetCustomPlayerColor ()
{
	ResetConfig ("CustomPlayerColor");

	StaticSaveConfig ();
}

// ##

static final function ShowResources ()
{
	Default.bShowTeamResources = !Default.bShowTeamResources;

	StaticSaveConfig ();
}

static final function string GetRelativePlayerColorCodedString (int IndexTeam_Local, int IndexTeam_Other)
{
	// Spectators

	if (IndexTeam_Local == IndexTeam_Unspecified)
	{
		return
		(
			Chr (0x1B)
			$ Chr (Max (Default.StandardTeamColor[IndexTeam_Other].R, 1))
			$ Chr (Max (Default.StandardTeamColor[IndexTeam_Other].G, 1))
			$ Chr (Max (Default.StandardTeamColor[IndexTeam_Other].B, 1))
		);
	}

	// Allies

	if (IndexTeam_Local == IndexTeam_Other) // Use Relative Colors
	{
		if (UseCustomTeammateColor ())
		{
			return
			(
				Chr (0x1B)
				$ Chr (Max (Default.CustomTeammateColor.R, 1))
				$ Chr (Max (Default.CustomTeammateColor.G, 1))
				$ Chr (Max (Default.CustomTeammateColor.B, 1))
			);
		}
		else
		{
			return
			(
				Chr (0x1B)
				$ Chr (Max (Default.StandardTeamColor[IndexTeam_Other].R, 1))
				$ Chr (Max (Default.StandardTeamColor[IndexTeam_Other].G, 1))
				$ Chr (Max (Default.StandardTeamColor[IndexTeam_Other].B, 1))
			);
		}
	}

	// Enemies
	// - Assumed that (IndexTeam_Local != IndexTeam_Other) because both
	// spectator and same team have been handled already.

	if (UseCustomEnemyColor ()) // Enemies
	{
		return
		(
			Chr (0x1B)
			$ Chr (Max (Default.CustomEnemyColor.R, 1))
			$ Chr (Max (Default.CustomEnemyColor.G, 1))
			$ Chr (Max (Default.CustomEnemyColor.B, 1))
		);
	}
	else
	{
		return
		(
			Chr (0x1B)
			$ Chr (Max (Default.StandardTeamColor[IndexTeam_Other].R , 1))
			$ Chr (Max (Default.StandardTeamColor[IndexTeam_Other].G , 1))
			$ Chr (Max (Default.StandardTeamColor[IndexTeam_Other].B , 1))
		);
	}
}

static final function ShowRadar ()
{
	Default.bShowTeammateRadar = !Default.bShowTeammateRadar;

	StaticSaveConfig ();
}

static final function ShowDamage ()
{
	Default.bShowDamagePoints = !Default.bShowDamagePoints;

	StaticSaveConfig ();
}

// #

static final function MoveRadar (int X, int Y)
{
	Default.TeammateRadarPosX = FClamp (X / 100.0f, 0.0f, 1.0f);
	Default.TeammateRadarPosY = FClamp (Y / 100.0f, 0.0f, 1.0f);

	StaticSaveConfig ();
}

static final function ResetRadar ()
{
	Default.TeammateRadarPosX = 0.2;
	Default.TeammateRadarPosY = 0.04;
	Default.TeammateRadarSize = 0.1;

	StaticSaveConfig ();
}

static final function SizeRadar (int UV)
{
	Default.TeammateRadarSize = FClamp (UV / 100.0f, 0.01, 1.0f);

	StaticSaveConfig ();
}

// #

DefaultProperties
{
	EnemyNameFontSize = 1

	//

	bPickupsBumpReticle = False

	//

	bShowAwardStatusAnnouncements = True

	// Announcements

	bAnnounceMatchPoint = True
	bAnnounceOverkill = True
	bAnnounceOvertime = True
	bAnnounceRespawnsDepleted = True
	bAnnounceSuddenDeath = True

	//

	bStatisticsShowPortraits = True

	//

	bTakeEndGameScreenShot = False

 	// Chat

	ChatMessageLifetime_Min = 1
	ChatMessageLifetime_Max = 10
	ChatMessageLifetime = 8

	bChatMessageStay = False
	bChatMessageLog = False

	// #Characters

	bUnlitCharacters = True

	CustomEnemyAmbientGlow = 40
	CustomTeammateAmbientGlow = 40

	bReplaceTeammateCharacters = False
	TeammateReplacementCharacterNameString = "Jakob"

	bReplaceEnemyCharacters = False
	EnemyReplacementCharacterNameString = "Tamika"

	// #Skins

	CustomSkinType = ES_Relative

	ScaledCustomSkinColor = 2.0

	CustomTeammateSkinColor = (R=0,G=0,B=0,A=255)
	CustomEnemySkinColor = (R=0,G=0,B=0,A=255)

	StandardTeamSkinColor(0) = (R=100,G=0,B=0,A=255)
	StandardTeamSkinColor(1) = (R=0,G=31,B=100,A=255)

	// #Colors

	AnnouncementColor = (R=255,G=255,B=15,A=255)
	MessageColor = (R=239,G=239,B=239,A=255)
	HeadshotDamageTypeColor = (R=255,G=255,B=255,A=255)
	GeneralDamageTypeColor = (R=255,G=255,B=255,A=255)
	UnknownDamageTypeColor = (R=255,G=255,B=255,A=255)
	WeaponDamageTypeColor = (R=255,G=255,B=255,A=255)
	ItemColor = (R=239,G=239,B=239,A=255)
	PlayerTeamSayColor = (R=128,G=255,B=128,A=255)
	CustomPlayerColor = (R=234,G=191,B=69,A=255)
	EnemyPlayerColor = (R=223,G=223,B=223,A=255)
	SpectatorSayColor = (R=255,G=255,B=0,A=255)
	SpectatorTeamSayColor = (R=128,G=255,B=128,A=255)
	UnknownPlayerColor = (R=191,G=191,B=191,A=255)

	// #NetworkMetrics

	PingPosX = 0.95
	PingPosY = 0.085
	PacketLossPosX = 0.98
	PacketLossPosY = 0.085

	// #Award

	AwardDrawColor = (R=0,G=160,B=255,A=200)
	AwardDrawPivot = DP_MiddleMiddle
	AwardPosX = 0.5
	AwardPosY = 0.242
	AwardFontSize = 1
	AwardLifetime = 4
	AwardStackMode = SM_Down

	//

	bShowCombatTyping = True

	// #Warnings

	bShowTimeWarnings = True
	bFiveMinuteWarning = True
	bThreeMinuteWarning = True
	bTwoMinuteWarning = True
	bOneMinuteWarning = True
	bThirtySecondWarning = True
	bTwentySecondWarning = True
	bTenSecondWarning = False
	bFiveSecondCountdown = True

	//

	bShowDamagePoints = False
	DamagePointFontSize = -1

	//
	
	bShowSpawnProtection = True

	//
	
	bShowOwnDeathMessage = True

	//

	DeathMessage_Type = 1

	DeathMessage_Type_Min = 0
	DeathMessage_Type_Max = 3

	DeathMessage_bUseWeaponColor = False
	DeathMessage_bUseWeaponName = True

	//

	bShowDamageIndicators = True
	bUseTrackingDamageIndicators = True

	//

	bShowEventBeacons = True
	bShowEventBeaconDistance = True
	EventBeaconFontSize = -2

	//

	bUseHitSounds = True
	HitSoundVolume = 0.6

	//

	LastManOut_Sound = Sound'Sounds.Alone'
	LastManOutSoundVolume = 1.0

	// Location Name

	bShowLocationName = True
	MinLocationNameOpacity = 63
	MaxLocationNameOpacity = 255
	LocationNameColor = (R=255,G=255,B=255,A=143)
	LocationNameFontSize = -2
	LocationNamePosX = 0
	LocationNamePosY = 0

	//

	bDrawTeammateRadarHeightDot = True

	//

	bShowVictimDamageType = True

	//

	bShowNet = True

	//

	bShowTeamCombos = True

	//

	bTeamColoredEnemyName = False

	//

	ShowScoreboardWaitDelay = 5

	// Pickup Message Types

	bShowPickupMessage = True
	PickupMessageType = 2
	MinPickupMessageType = 0
	MaxPickupMessageType = 2

	//

	bRequestMatchStatistics = False

	//

	bShowScoreboardSpectators = True
	bShowScoreboardVersus = False

	//

	bShowEnemyStatus = True
	bShowTeammateStatus = True

	//

	bScoreboardShowPlayerPortrait = False

	//

	CustomTeammateColor = (R=0,G=0,B=0,A=255)
	CustomEnemyColor = (R=0,G=0,B=0,A=255)

	//
	
	ScoreboardOpacity = 255

	//

	StandardTeamColor(0) = (R=255,G=64,B=64,A=255) // Absolute Red
	StandardTeamColor(1) = (R=64,G=192,B=255,A=255) // Absolute Blue

	//

	TeammateRadarPosX = 0.2
	TeammateRadarPosY = 0.04
	TeammateRadarSize = 0.1

	//

	MinTeamInfoRows = 1
	MaxTeamInfoRows = 16
	bShowTeamInfo = True
	bShowTeamInfoStatus = True
	bShowTeamInfoCountry = True
	bShowTeamInfoLocation = True
	TeamInfoFontSize = -3
	TeamInfoRows = 7

	//

	MinEnemyInfoRows = 1
	MaxEnemyInfoRows = 16

	bShowEnemyInfo = True
	bShowEnemyInfoStatus = True
	bShowEnemyInfoCountry = True

	EnemyInfoFontSize = -3
	EnemyInfoRows = 7

	// Teammate Radar

	bShowTeammateRadar = True

	// Team Resources

	bShowTeamResources = True

	//

	bShowBalanceTeams = True

	//

	bShowPlayerEvents = True
	bShowPlayersLeaving = True
	bShowPlayersChangingTeams = True
	bShowPlayersSpectating = True

	// Camper

	bShowCamperMessage = True

	// Pickup

	bShowTeammatePickupBroadcasts = True
	bShowEnemyPickupBroadcasts = True
	bTeamColoredPickupBroadcasts = False
}
