// Developed 2011-2013 rejecht <rejecht at outlook dot com>

class ScoreRecoveryObject_Re extends ScoreRecoveryObject
    ;

// #Engine.PlayerReplicationInfo

var float Score;
var float Deaths;
var int NumLives; // Problem: Has spent 1 life, gets DC and killed, has spent two lives, but saved that has spent 1 life.
var int Kills;
var int StartTime;
var int GoalsScored;
var bool bOutofLives;

// #UnrealGame.TeamPlayerReplicationInfo

var byte Spree[6];
var byte MultiKills[7];

// #RePRI

var RePRI.SMetrics Metrics;
var array<RePRI.SAwardRecord> AwardRecord;
var protected array<RePRI.SStatistics_Damage> Statistics_Damage;
var protected array<RePRI.SStatistics_Weapon> Statistics_Weapon;
var array<RePRI.SStatistics_WeaponDamage> Statistics_WeaponDamage;
var protected array<RePRI.SStatistics_Event> Statistics_Event;
var array<RePRI.SStatistics_AdrenalineCombo> Statistics_AdrenalineCombo;
var int IndexRound_Joined;

var float ScaledReverseFriendlyFire;
var int ReverseFFTeammateDamage;
var int Retribution_PlayerID_LastEnemyKiller;
var int ReplicatedKills;

// **

var int KillingSpree_Count;
var int Multikill_Count;
var float Multikill_TimeSeconds_Last;
var protected float TimeSeconds_Joined;

// ##

// *F* 2013-01-01

protected function Update_PlayerReplicationInfo (RePRI RePRI)
{
    local int Index;

    Score = RePRI.Score;
    Deaths = RePRI.Deaths;
    NumLives = RePRI.NumLives;
    Kills = RePRI.Kills;
    StartTime = RePRI.StartTime;
    GoalsScored = RePRI.GoalsScored;
    bOutofLives = RePRI.bOutofLives;

    // ** Spree

    for (Index = 0; Index < ArrayCount(RePRI.Spree); ++Index)
    {
        Spree[Index] = RePRI.Spree[Index];
    }

    // ** MultiKill

    for (Index = 0; Index < ArrayCount(RePRI.MultiKills); ++Index)
    {
        MultiKills[Index] = RePRI.MultiKills[Index];
    }
}

// ##

// *F* 2013-01-01

function Update (RePlayer RePC)
{
    local RePRI RePRI;
    local int Index;

    super.Update (RePC);

    // **

    RePRI = RePRI(RePC.PlayerReplicationInfo);

    // **

    Update_PlayerReplicationInfo (RePRI);

	// **

	ScaledReverseFriendlyFire = RePRI.ScaledReverseFriendlyFire;
	ReverseFFTeammateDamage = RePRI.ReverseFFTeammateDamage;
	Retribution_PlayerID_LastEnemyKiller = RePRI.Retribution_PlayerID_LastEnemyKiller;
	ReplicatedKills = RePRI.ReplicatedKills;

    // **
    // - Player was in practise killed when disconnected.

    KillingSpree_Count = 0;
    Multikill_Count = 0;
    Multikill_TimeSeconds_Last = 0.0f;

    // **
    // - This value still holds true.

    TimeSeconds_Joined = RePRI.TimeSeconds_Joined;

    // ** Metrics

    Metrics = RePRI.Metrics;

    // ** AwardRecord

    AwardRecord.Length = RePRI.AwardRecord.Length;

    for (Index = 0; Index < AwardRecord.Length; ++Index)
    {
        AwardRecord[Index] = RePRI.AwardRecord[Index];
    }

    // ** Statistics_Damage

    Statistics_Damage.Length = RePRI.Statistics_Damage.Length;

    for (Index = 0; Index < Statistics_Damage.Length; ++Index)
    {
        Statistics_Damage[Index] = RePRI.Statistics_Damage[Index];
    }

    // ** Statistics_Weapon

    Statistics_Weapon.Length = RePRI.Statistics_Weapon.Length;

    for (Index = 0; Index < Statistics_Weapon.Length; ++Index)
    {
        Statistics_Weapon[Index] = RePRI.Statistics_Weapon[Index];
    }

    // ** Statistics_WeaponDamage

    Statistics_WeaponDamage.Length = RePRI.Statistics_WeaponDamage.Length;

    for (Index = 0; Index < Statistics_WeaponDamage.Length; ++Index)
    {
        Statistics_WeaponDamage[Index] = RePRI.Statistics_WeaponDamage[Index];
    }

    // ** Statistics_Event

    Statistics_Event.Length = RePRI.Statistics_Event.Length;

    for (Index = 0; Index < Statistics_Event.Length; ++Index)
    {
        Statistics_Event[Index] = RePRI.Statistics_Event[Index];
    }

    // ** Statistics_AdrenalineCombo

    Statistics_AdrenalineCombo.Length = RePRI.Statistics_AdrenalineCombo.Length;

    for (Index = 0; Index < Statistics_AdrenalineCombo.Length; ++Index)
    {
        Statistics_AdrenalineCombo[Index] = RePRI.Statistics_AdrenalineCombo[Index];
    }

	//

	IndexRound_Joined = RePRI.IndexRound_Joined;
}

// ##

// *F* 2013-01-01

function Restore (RePlayer RePC)
{
    local RePRI RePRI;
    local int Index;

    super.Restore (RePC);

    // **

    RePRI = RePRI(RePC.PlayerReplicationInfo);

    // **

    Restore_PlayerReplicationInfo (RePRI);

    // ** Spree

    for (Index = 0; Index < ArrayCount(Spree); ++Index)
    {
        RePRI.Spree[Index] = Spree[Index];
    }

    // ** MultiKill

    for (Index = 0; Index < ArrayCount(MultiKills); ++Index)
    {
        RePRI.MultiKills[Index] = MultiKills[Index];
    }

    // **
    // - This value still holds true.

    RePRI.TimeSeconds_Joined = TimeSeconds_Joined;

    // ** Metrics

    RePRI.Metrics = Metrics;

    // ** AwardRecord

    RePRI.AwardRecord.Length = AwardRecord.Length;

    for (Index = 0; Index < AwardRecord.Length; ++Index)
    {
        RePRI.AwardRecord[Index] = AwardRecord[Index];
    }

    // ** Statistics_Damage

    RePRI.Statistics_Damage.Length = Statistics_Damage.Length;

    for (Index = 0; Index < Statistics_Damage.Length; ++Index)
    {
        RePRI.Statistics_Damage[Index] = Statistics_Damage[Index];
    }

    // ** Statistics_Weapon

    RePRI.Statistics_Weapon.Length = Statistics_Weapon.Length;

    for (Index = 0; Index < Statistics_Weapon.Length; ++Index)
    {
        RePRI.Statistics_Weapon[Index] = Statistics_Weapon[Index];
    }

    // ** Statistics_WeaponDamage

    RePRI.Statistics_WeaponDamage.Length = Statistics_WeaponDamage.Length;

    for (Index = 0; Index < Statistics_WeaponDamage.Length; ++Index)
    {
        RePRI.Statistics_WeaponDamage[Index] = Statistics_WeaponDamage[Index];
    }

    // ** Statistics_Event

    RePRI.Statistics_Event.Length = Statistics_Event.Length;

    for (Index = 0; Index < Statistics_Event.Length; ++Index)
    {
        RePRI.Statistics_Event[Index] = Statistics_Event[Index];
    }

    // ** Statistics_AdrenalineCombo

    RePRI.Statistics_AdrenalineCombo.Length = Statistics_AdrenalineCombo.Length;

    for (Index = 0; Index < Statistics_AdrenalineCombo.Length; ++Index)
    {
        RePRI.Statistics_AdrenalineCombo[Index] = Statistics_AdrenalineCombo[Index];
    }

    // **

	RePRI.ScaledReverseFriendlyFire = ScaledReverseFriendlyFire;
	RePRI.ReverseFFTeammateDamage = ReverseFFTeammateDamage;
	RePRI.Retribution_PlayerID_LastEnemyKiller = Retribution_PlayerID_LastEnemyKiller;
	RePRI.ReplicatedKills = ReplicatedKills;

    // **

	RePRI.IndexRound_Joined = IndexRound_Joined;
}

// *F* 2013-01-01

protected function Restore_PlayerReplicationInfo (RePRI RePRI)
{
    local int Index;

    RePRI.Score = Score;
    RePRI.Deaths = Deaths;
    RePRI.NumLives = NumLives;
    RePRI.Kills = Kills;
    RePRI.StartTime = StartTime;
    RePRI.GoalsScored = GoalsScored;
    RePRI.bOutofLives = bOutofLives;

    // ** Spree

    for (Index = 0; Index < ArrayCount(RePRI.Spree); ++Index)
    {
        Spree[Index] = RePRI.Spree[Index];
    }

    // ** MultiKill

    for (Index = 0; Index < ArrayCount(RePRI.MultiKills); ++Index)
    {
        MultiKills[Index] = RePRI.MultiKills[Index];
    }
}

// ##

DefaultProperties
{
}
