// *I* Developed 2013 rejecht <rejecht at outlook dot com>

// - To spawn a FlakShellChunk instead of FlakChunk in order
// to differentiate between primary and alternate mode in stats.

class Statistics_FlakShell extends FlakShell
	;

// #

var const int Chunks;
var const Class<FlakChunk> TertiaryProjectileClass;

// #Lifetime

simulated event PostBeginPlay ()
{
	Super.PostBeginPlay ();
}

// #

simulated event Explode (Vector HitLocation, Vector HitNormal)
{
    local FlakChunk NewChunk;
	local vector start;
    local rotator rot;
    local int Index;

	start = Location + 10 * HitNormal;

	if (Role == ROLE_Authority)
	{
		HurtRadius (Damage, 220, MyDamageType, MomentumTransfer, HitLocation); // Base damage at impact point.

		// Spawn additional shell shrapnel

		for (Index = 0; Index < Chunks; ++Index)
		{
			rot = Rotation;

			rot.yaw += FRand()*32000-16000;
			rot.pitch += FRand()*32000-16000;
			rot.roll += FRand()*32000-16000;

			NewChunk = Spawn (TertiaryProjectileClass,, '', Start, Rot);
		}
	}


    Destroy ();
}

// #

DefaultProperties
{
	Chunks = 6

	TertiaryProjectileClass = Class'Statistics_FlakShellChunk'
}
