// *F* Developed 2011-2013 rejecht <rejecht at outlook dot com>

// - Logs primary and alternate firing modes.
// - Alternate only logged when not linking.

class Statistics_LinkGun extends LinkGun
	CacheExempt
	;

// #Statistics

var(Cached) protected int Statistics_FireModeIndex[NUM_FIRE_MODES];

// #Lifetime

simulated event PostBeginPlay ()
{
	Super.PostBeginPlay ();


	if (Role == ROLE_Authority)
	{
		Statistics_PostBeginPlay ();
    }
}

// #Statistics

protected function Statistics_PostBeginPlay ()
{
	local AwardPRI AwardPRI;
	
	AwardPRI = AwardPRI(Instigator.PlayerReplicationInfo);

	Statistics_FireModeIndex[0] = AwardPRI.Statistics_RegisterWeaponDamageType (Class'XWeapons.DamTypeLinkPlasma', 0);
	Statistics_FireModeIndex[1] = AwardPRI.Statistics_RegisterWeaponDamageType (Class'XWeapons.DamTypeLinkShaft', 1);
}

// #

simulated event bool ConsumeAmmo (int Mode, float Load, optional bool bAmountNeededIsMax)
{
	local AwardPRI AwardPRI;
	local bool bConsumed;

	AwardPRI = AwardPRI(Instigator.PlayerReplicationInfo);

	bConsumed = Super.ConsumeAmmo (Mode, Load, bAmountNeededIsMax);

	if
	(
		(Role == ROLE_Authority)
		&&
		bConsumed
		&&
		(AwardPRI != None)
	)
	{
		if (Mode == 0)
		{
			AwardPRI.Statistics_LogWeaponFiredByIndex (Statistics_FireModeIndex[0], 1);
        }
        else if
        (
			(Mode == 1)
			&&
			!Linking
		)
        {
			AwardPRI.Statistics_LogWeaponFiredByIndex (Statistics_FireModeIndex[1], 1);
        }
	}

	return bConsumed;
}

// #

DefaultProperties
{
	PickupClass = Class'Statistics_LinkgunPickup'
}
