// *F* Developed 2011-2013 rejecht <rejecht at outlook dot com>

class Statistics_ShieldGun extends ShieldGun
	CacheExempt
	;

// #Statistics

var(Cached) protected int Statistics_FireModeIndex;

// #Lifetime

simulated event PostBeginPlay ()
{
	Super.PostBeginPlay ();


	if (Role == ROLE_Authority)
	{
		Statistics_PostBeginPlay ();
    }
}

// #Statistics

protected function Statistics_PostBeginPlay ()
{
	local AwardPRI AwardPRI;

	AwardPRI = AwardPRI(Instigator.PlayerReplicationInfo);

	Statistics_FireModeIndex = AwardPRI.Statistics_RegisterWeaponDamageType (Class'XWeapons.DamTypeShieldImpact', 0);
}

// #

simulated event bool ConsumeAmmo (int Mode, float Load, optional bool bAmountNeededIsMax)
{
	local AwardPRI AwardPRI;
	local bool bConsumed;

	AwardPRI = AwardPRI(Instigator.PlayerReplicationInfo);

	bConsumed = Super.ConsumeAmmo (Mode, Load, bAmountNeededIsMax);

	if
	(
		(Role == ROLE_Authority)
		&&
		(Mode == 0) // Only interested in primary firing mode.
		&&
		bConsumed
		&&
		(AwardPRI != None)
	)
	{
		AwardPRI.Statistics_LogWeaponFiredByIndex (Statistics_FireModeIndex, 1);
	}

	return bConsumed;
}

// #

// *UT2004Fix* @GreatEmerald

simulated event AnimEnd (int Channel)
{
    if (FireMode[0].bIsFiring)
    {
        LoopAnim ('Charged');
    }
    else if (!FireMode[1].bIsFiring)
    {
        Super(Weapon).AnimEnd (Channel);
    }
}

// #

DefaultProperties
{
}
