// *F* Developed 2014 rejecht <rejecht at outlook dot com>
// - Adapted from 3SPN implementation.

class TeamComboReplicationInfo extends ReplicationInfo
	;

// #

const ActiveComboLimit = 16;

const ActivityInterval = 0.5f;

var float RemainingTime[ActiveComboLimit];
var byte Type[ActiveComboLimit];

// #

var(Replicated) bool bRunning;

replication
{
	reliable if (Role == ROLE_Authority)
		bRunning, RemainingTime, Type;
}

// #Lifetime

simulated event PostBeginPlay ()
{
	Super.PostBeginPlay ();


	if (Level.NetMode != NM_DedicatedServer)
	{
		SetTimer (ActivityInterval, True);
	}
}

// #

simulated event Timer ()
{
	local int Index;

	if (bRunning)
	{
		for (Index = 0; Index < ActiveComboLimit; ++Index)
		{
			if (RemainingTime[Index] > 0.0f)
			{
				RemainingTime[Index] -= ActivityInterval;
			}
		}
	}
}

// #

DefaultProperties
{
	// Actor

	NetPriority = 0.5
	NetUpdateFrequency = 2.0
}
