// *F* Developed 2011-2014 rejecht <rejecht at outlook dot com>

class UT2K4Tab_AdrenalineCombos extends UT2K4Tab_MidGameOptions
	HideDropDown
	;

var protected automated GUISectionBackground sb_Background;

var automated GUIMultiOptionListBox lb_Box;
var GUIMultiOptionList li_Options;

var protected int OptionTabOrder;

var protected array<SOption> Options_AdrenalineCombo;

var protected localized const string
	BlockStringPrefix,
	BlockStringSuffix
	;

var protected class<Combo> ComboClassGroup[16];
var protected string ComboKeysGroup[16];
var protected int ComboClassGroupLength;

// var protected bool bReceivedCombos;

event InitComponent (GUIController MyController, GUIComponent MyOwner)
{
	Super.InitComponent (MyController, MyOwner);


	li_Options = lb_Box.List;
	li_Options.OnCreateComponent = ListOnCreateComponent;


	UpdateOptions ();
}

function UpdateOptions ()
{
	local xPlayer xPlayerOwner;
	local class<Combo> ComboClass;
	local string Text_KeyCombo;
	local int
		Index,
		IndexCombo;

	ComboClassGroupLength = 0;

	Option_Reset ();

	xPlayerOwner = xPlayer(PlayerOwner ());

	for (Index = 0; Index < Options_AdrenalineCombo.Length; ++Index)
	{
		if (xPlayerOwner.ComboNameList[Index] != "")
		{
			ComboClass = Class<Combo>(DynamicLoadObject (xPlayerOwner.ComboNameList[Index], Class'Core.Class'));

			if (ComboClass != None)
			{
				Text_KeyCombo = Class'ReUtility'.Static.GetKeyComboString (ComboClass);

				if (ComboClass.Default.ExecMessage != "")
				{
					Options_AdrenalineCombo[Index].Caption = BlockStringPrefix $ ComboClass.Default.ExecMessage $ BlockStringSuffix @ "(" $ Text_KeyCombo $ ")";

					ComboKeysGroup[IndexCombo] = Text_KeyCombo;
					ComboClassGroup[IndexCombo] = ComboClass;
					++IndexCombo;
                }
                else if (Text_KeyCombo != "????")
                {
					Options_AdrenalineCombo[Index].Caption = BlockStringPrefix $ "(" $ Text_KeyCombo $ ")" $ BlockStringSuffix;

					ComboKeysGroup[IndexCombo] = Text_KeyCombo;
					ComboClassGroup[IndexCombo] = ComboClass;
					++IndexCombo;
                }
            }
        }
    }

    //

    ComboClassGroupLength = IndexCombo;

	// Add Group

	if (ComboClassGroupLength > 0)
	{
		Option_AddGroup (li_Options, Options_AdrenalineCombo, ComboClassGroupLength);
    }
}

protected function DisableAdrenalineCombo (string Text_Combo)
{
	Class'PlayerSettings'.Static.DisableAdrenalineCombo (Text_Combo);
}

protected function EnableAdrenalineCombo (string Text_Combo)
{
	Class'PlayerSettings'.Static.EnableAdrenalineCombo (Text_Combo);
}

event InternalOnChange (GUIComponent Sender)
{
	if (GUIMultiOptionList(Sender) != None)
	{
		Option_OnChange (GUIMultiOptionList(Sender).Get ());
	}
}


event InternalOnCreateComponent (GUIComponent NewComp, GUIComponent Sender)
{
	if (GUIMultiOptionList(NewComp) != None)
	{
		GUIMultiOptionList(NewComp).bDrawSelectionBorder = False;
		GUIMultiOptionList(NewComp).ItemPadding = 0.3f;

		if (Sender == lb_Box) // Pass it on to GUIMultiOptionListBox, since intercepted.
		{
			lb_Box.InternalOnCreateComponent (NewComp, Sender);
		}
	}
}


function ListOnCreateComponent (GUIMenuOption NewComp, GUIMultiOptionList Sender)
{
	NewComp.LabelJustification = TXTA_Left;
	NewComp.ComponentJustification = TXTA_Right;

	if (NewComp.IsA ('GUIListHeader'))
	{
		NewComp.StyleName = "NoBackground";
		NewComp.LabelStyleName = "TextLabel";
		NewComp.FontScale = FNS_Medium;
	}
}

// #Options

protected function Option_Append (int IndexTag, name Property)
{
	local int Index;

	Index = Group_Component.Length;

	Group_Component.Length = Group_Component.Length + 1;

	Group_Component[Index].IndexTag = IndexTag;
	Group_Component[Index].Property = Property;
}

protected function name Option_OutText_PropertyName (int IndexTag)
{
	local int Index;
	local int Count;

	Count = Group_Component.Length;

	for (Index = 0; Index < Count; ++Index)
	{
		if (Group_Component[Index].IndexTag == IndexTag)
		{
			return Group_Component[Index].Property;
		}
	}

	return '';
}

protected function bool IsAdrenalineComboDisabled (string Text_KeyCombo)
{
	return Class'PlayerSettings'.Static.AdrenalineComboDisabled (Text_KeyCombo);
}

protected function Option_OnCreate (GUIMenuOption moNew, name Property)
{
	switch (moNew.Tag)
	{
		case 0:
		case 1:
		case 2:
		case 3:
		case 4:
		case 5:
		case 6:
		case 7:
		case 8:
		case 9:
		case 10:
		case 11:
		case 12:
		case 13:
		case 14:
		case 15:
			moCheckBox(moNew).Checked (IsAdrenalineComboDisabled (ComboKeysGroup[moNew.Tag]));
			break;

		default:
			Warn ("Unhandled: Property" @ Property);
			break;
	}
}

protected function Option_OnChange (GUIMenuOption moChanged)
{
	switch (moChanged.Tag)
	{
		case 0:
		case 1:
		case 2:
		case 3:
		case 4:
		case 5:
		case 6:
		case 7:
		case 8:
		case 9:
		case 10:
		case 11:
		case 12:
		case 13:
		case 14:
		case 15:
			if (moCheckBox(moChanged).IsChecked ())
			{
				DisableAdrenalineCombo (ComboKeysGroup[moChanged.Tag]);
            }
            else
            {
				EnableAdrenalineCombo (ComboKeysGroup[moChanged.Tag]);
            }
			break;

		default:
			Warn ("Unhandled: " @ Option_OutText_PropertyName (moChanged.Tag));
			break;
	}
}

protected function Option_Reset ()
{
	Option_IndexTag = 0;
	Option_Group.Length = 0;
}

// - To add the options to the list.
// - To call Option_OnCreate for every option added.

protected function Option_AddGroup (GUIMultiOptionList moList, array<SOption> OptionGroup, int Limit)
{
	local GUIMenuOption moNew;
	local int Index;
	local int Count;

	Count = OptionGroup.Length;

	if (Limit < Count)
	{
		Count = Limit;
    }

	for (Index = 0; Index < Count; ++Index)
	{
		moNew
		=
		moList.AddItem
		(
			Text_ClassName_Component[OptionGroup[Index].Component],
			,
			OptionGroup[Index].Caption
		);

		if (moNew != None)
		{
			moNew.Tag = Option_IndexTag;

			moNew.bAutoSizeCaption = True;

			if (OptionGroup[Index].Component != C_Section)
			{
				moNew.TabOrder = OptionTabOrder++;

				Option_Append (Option_IndexTag, OptionGroup[Index].Property);

				if (OptionGroup[Index].Description != "")
				{
					moNew.SetHint (OptionGroup[Index].Description);
				}

				Option_OnCreate (moNew, OptionGroup[Index].Property);

				++Option_IndexTag;
			}
		}
		else
		{
			Warn ("(moNew == None) -- moList:"@moList@"moNew:"@moNew@"Index:"@Index);
		}
	}
}

// #

protected function ToggleAdrenalineCombo (string Text_Combo)
{
}

// #

DefaultProperties
{
    Begin Object Class=AltSectionBackground Name=sbBackground
        Caption="Blocked Adrenaline Combos"
        LeftPadding=0.0
        RightPadding=0.0
        TopPadding=0.0
        BottomPadding=0.0
		WinLeft=0.023625
		WinTop=0.025
		WinWidth=0.944875
		WinHeight=0.9
        bBoundToParent = true
        bScaleToParent = true
    End Object

    sb_Background = sbBackground

	Begin Object Class=GUIMultiOptionListBox Name=ConfigList
		bVisibleWhenEmpty = True
		bBoundToParent = True
		bScaleToParent = True
		NumColumns = 1
		OnCreateComponent = InternalOnCreateComponent
		OnChange = InternalOnChange
		RenderWeight = 0.9
		StyleName = "NoBackground"
		TabOrder = 1
		WinLeft = 0.1f
		WinTop = 0.1f
		WinWidth = 0.8f
		WinHeight = 0.825f
	End Object

	lb_Box = ConfigList

	BlockStringPrefix = "Block "

	// Options

	OptionTabOrder = 2;

	Options_AdrenalineCombo(0) = (Component=C_Boolean)
	Options_AdrenalineCombo(1) = (Component=C_Boolean)
	Options_AdrenalineCombo(2) = (Component=C_Boolean)
	Options_AdrenalineCombo(3) = (Component=C_Boolean)
	Options_AdrenalineCombo(4) = (Component=C_Boolean)
	Options_AdrenalineCombo(5) = (Component=C_Boolean)
	Options_AdrenalineCombo(6) = (Component=C_Boolean)
	Options_AdrenalineCombo(7) = (Component=C_Boolean)
	Options_AdrenalineCombo(8) = (Component=C_Boolean)
	Options_AdrenalineCombo(9) = (Component=C_Boolean)
	Options_AdrenalineCombo(10) = (Component=C_Boolean)
	Options_AdrenalineCombo(11) = (Component=C_Boolean)
	Options_AdrenalineCombo(12) = (Component=C_Boolean)
	Options_AdrenalineCombo(13) = (Component=C_Boolean)
	Options_AdrenalineCombo(14) = (Component=C_Boolean)
	Options_AdrenalineCombo(15) = (Component=C_Boolean)
}
