// Developed 2011-2013 rejecht <rejecht at outlook dot com>

class UT2K4Tab_Announcements extends UT2K4Tab_MidGameOptions
	HideDropDown
	;

var automated GUIMultiOptionListBox lb_Box;
var GUIMultiOptionList li_Options;

var protected int OptionTabOrder;

var protected automated GUISectionBackground sb_Background;

var protected array<SOption> Options_Announcements;

// #

protected function Option_OnCreate (GUIMenuOption moNew, name Property)
{
	switch (Property)
	{
		case 'LastManOutVolume':
			moSlider(moNew).Setup (0.0f, 1.0f);
			moNew.SetComponentValue (FClamp (Class'PlayerSettings'.Default.LastManOutSoundVolume, 0.0f, 1.0f));
			return;

		case 'bAnnounceOverkill':
			moNew.SetComponentValue (Class'PlayerSettings'.default.bAnnounceOverkill);
			return;

		case 'bAnnounceMatchPoint':
			moNew.SetComponentValue (Class'PlayerSettings'.default.bAnnounceMatchPoint);
			return;

		case 'bAnnounceRespawnsDepleted':
			moNew.SetComponentValue (Class'PlayerSettings'.default.bAnnounceRespawnsDepleted);
			return;

		case 'bAnnounceOvertime':
			moNew.SetComponentValue (Class'PlayerSettings'.default.bAnnounceOvertime);
			return;

		case 'bAnnounceSuddenDeath':
			moNew.SetComponentValue (Class'PlayerSettings'.default.bAnnounceSuddenDeath);
			return;


		case 'bShowAwardStatusAnnouncements':
			moNew.SetComponentValue (Class'PlayerSettings'.default.bShowAwardStatusAnnouncements);
			return;

		case 'bShowEnemyStatus':
			moNew.SetComponentValue (Class'PlayerSettings'.default.bShowEnemyStatus);
			return;

		case 'bShowTeammateStatus':
			moNew.SetComponentValue (Class'PlayerSettings'.default.bShowTeammateStatus);
			return;

		case 'bShowTimeWarnings':
			moNew.SetComponentValue (Class'PlayerSettings'.default.bShowTimeWarnings);
			return;

		case 'bShowPlayerEvents':
			moNew.SetComponentValue (Class'PlayerSettings'.default.bShowPlayerEvents);
			return;

		default:
			Warn ("Unhandled: Property"@Property);
			break;
	}
}

protected function Option_OnChange (GUIMenuOption moChanged)
{
	switch (Option_OutText_PropertyName (moChanged.Tag))
	{
		case 'LastManOutVolume':
			Class'PlayerSettings'.default.LastManOutSoundVolume = float(moChanged.GetComponentValue ());
			Class'PlayerSettings'.static.StaticSaveConfig ();
			AuditionLastManOut ();
			return;


		case 'bAnnounceOverkill':
			Class'PlayerSettings'.default.bAnnounceOverkill = bool(moChanged.GetComponentValue ());
			Class'PlayerSettings'.static.StaticSaveConfig ();
			return;

		case 'bAnnounceMatchPoint':
			Class'PlayerSettings'.default.bAnnounceMatchPoint = bool(moChanged.GetComponentValue ());
			Class'PlayerSettings'.static.StaticSaveConfig ();
			return;

		case 'bAnnounceRespawnsDepleted':
			Class'PlayerSettings'.default.bAnnounceRespawnsDepleted = bool(moChanged.GetComponentValue ());
			Class'PlayerSettings'.static.StaticSaveConfig ();
			return;

		case 'bAnnounceOvertime':
			Class'PlayerSettings'.default.bAnnounceOvertime = bool(moChanged.GetComponentValue ());
			Class'PlayerSettings'.static.StaticSaveConfig ();
			return;

		case 'bAnnounceSuddenDeath':
			Class'PlayerSettings'.default.bAnnounceSuddenDeath = bool(moChanged.GetComponentValue ());
			Class'PlayerSettings'.static.StaticSaveConfig ();
			return;

		case 'bShowAwardStatusAnnouncements':
			Class'PlayerSettings'.default.bShowAwardStatusAnnouncements = bool(moChanged.GetComponentValue ());
			Class'PlayerSettings'.static.StaticSaveConfig ();
			return;

		case 'bShowTeammateStatus':
			Class'PlayerSettings'.default.bShowTeammateStatus = bool(moChanged.GetComponentValue ());
			Class'PlayerSettings'.static.StaticSaveConfig ();
			return;

		case 'bShowEnemyStatus':
			Class'PlayerSettings'.default.bShowEnemyStatus = bool(moChanged.GetComponentValue ());
			Class'PlayerSettings'.static.StaticSaveConfig ();
			return;

		case 'bShowTimeWarnings':
			Class'PlayerSettings'.default.bShowTimeWarnings = bool(moChanged.GetComponentValue ());
			Class'PlayerSettings'.static.StaticSaveConfig ();
			return;


		case 'bShowPlayerEvents':
			Class'PlayerSettings'.default.bShowPlayerEvents = bool(moChanged.GetComponentValue ());
			Class'PlayerSettings'.static.StaticSaveConfig ();
			return;


		default:
			Warn ("Unhandled: "@Option_OutText_PropertyName (moChanged.Tag));
			break;
	}
}

protected function AuditionLastManOut ()
{
	local float Atten;

	if (Class'PlayerSettings'.Default.LastManOutSoundVolume > 0.0f)
	{
		Atten = FClamp (0.1f + Class'PlayerSettings'.Default.LastManOutSoundVolume * 0.225f, 0.2f, 1.0f);

		PlayerOwner ().ClientPlaySound (Class'PlayerSettings'.Default.LastManOut_Sound, True, Atten, SLOT_None);
    }
}

event InitComponent (GUIController MyController, GUIComponent MyOwner)
{
	Super.InitComponent (MyController, MyOwner);

	li_Options = lb_Box.List;
	li_Options.OnCreateComponent = ListOnCreateComponent;

	Option_Reset ();

	Option_AddGroup (li_Options, Options_Announcements);
}

event InternalOnChange (GUIComponent Sender)
{
	if (GUIMultiOptionList(Sender) != None)
	{
		Option_OnChange (GUIMultiOptionList(Sender).Get ());
	}
}

function ListOnCreateComponent (GUIMenuOption NewComp, GUIMultiOptionList Sender)
{
	NewComp.LabelJustification = TXTA_Left;
	NewComp.ComponentJustification = TXTA_Right;

	if (NewComp.IsA ('GUIListHeader'))
	{
		NewComp.StyleName = "NoBackground";
		NewComp.LabelStyleName = "TextLabel";
		NewComp.FontScale = FNS_Medium;
	}
}

event InternalOnCreateComponent (GUIComponent NewComp, GUIComponent Sender)
{
	if (GUIMultiOptionList(NewComp) != None)
	{
		GUIMultiOptionList(NewComp).bDrawSelectionBorder = False;
		GUIMultiOptionList(NewComp).ItemPadding = 0.3f;

		if (Sender == lb_Box) // Pass it on to GUIMultiOptionListBox, since intercepted.
		{
			lb_Box.InternalOnCreateComponent (NewComp, Sender);
		}
	}
}

// - To add the options to the list.
// - To call Option_OnCreate for every option added.

protected function Option_AddGroup (GUIMultiOptionList moList, array<SOption> OptionGroup)
{
	local GUIMenuOption moNew;
	local int Index;
	local int Count;

	Count = OptionGroup.Length;

	for (Index = 0; Index < Count; ++Index)
	{
		moNew
		=
		moList.AddItem
		(
			Text_ClassName_Component[OptionGroup[Index].Component],
			,
			OptionGroup[Index].Caption
		);

		if (moNew != None)
		{
			moNew.bAutoSizeCaption = True;

			if (OptionGroup[Index].Component != C_Section)
			{
				moNew.TabOrder = OptionTabOrder++;

				Option_Append (Option_IndexTag, OptionGroup[Index].Property);

				if (OptionGroup[Index].Description != "")
				{
					moNew.SetHint (OptionGroup[Index].Description);
				}

				Option_OnCreate (moNew, OptionGroup[Index].Property);

				moNew.Tag = Option_IndexTag++;
			}
		}
		else
		{
			Warn ("(moNew == None) -- moList:"@moList@"moNew:"@moNew@"Index:"@Index);
		}
	}
}

// ####

DefaultProperties
{
    Begin Object Class=AltSectionBackground Name=sbBackground
        Caption="Announcements"
        LeftPadding=0.0
        RightPadding=0.0
        TopPadding=0.0
        BottomPadding=0.0
		WinLeft=0.023625
		WinTop=0.025
		WinWidth=0.944875
		WinHeight=0.83
        bBoundToParent = True
        bScaleToParent = True
    End Object

    sb_Background = sbBackground

	Begin Object Class=GUIMultiOptionListBox Name=ConfigList
		bVisibleWhenEmpty = True
		bBoundToParent = True
		bScaleToParent = True
		NumColumns = 1
		OnCreateComponent = InternalOnCreateComponent
		OnChange = InternalOnChange
		RenderWeight = 0.9
		StyleName = "NoBackground"
		TabOrder = 1
		WinLeft = 0.1
		WinTop = 0.1
		WinWidth = 0.8
		WinHeight = 0.8125
	End Object

	lb_Box = ConfigList

	// Options

	OptionTabOrder = 2

	Options_Announcements(0) = (Caption="Last Man Out",Description="Plays for whoever is last out on the team. [0.0, 1.0]",Property=LastManOutVolume,Component=C_Range)
	Options_Announcements(1) = (Caption="Overkill",Property=bAnnounceOverkill,Component=C_Boolean)
	Options_Announcements(2) = (Caption="Overtime",Property=bAnnounceOvertime,Component=C_Boolean)
	Options_Announcements(3) = (Caption="Sudden Death",Property=bAnnounceSuddenDeath,Component=C_Boolean)
	Options_Announcements(4) = (Caption="Match Point",Property=bAnnounceMatchPoint,Component=C_Boolean)
	Options_Announcements(5) = (Caption="Respawns Depleted",Property=bAnnounceRespawnsDepleted,Component=C_Boolean)
	Options_Announcements(6) = (Caption="Awards & Status Messages",Property=bShowAwardStatusAnnouncements,Description="Shows Double Kill, Last Man Out, etc.",Component=C_Boolean)
	Options_Announcements(7) = (Caption="Enemy Killed/Out/Frozen/Thawed",Property=bShowEnemyStatus,Description="Enemy name and status shown on the bottom part of the HUD.",Component=C_Boolean)
	Options_Announcements(8) = (Caption="Teammate Killed/Out/Frozen/Thawed",Property=bShowTeammateStatus,Description="Teammate name and status shown on the bottom part of the HUD.",Component=C_Boolean)
	Options_Announcements(9) = (Caption="Show Remaining Time Warning",Property=bShowTimeWarnings,Description="Shows Two minutes remain, thirty seconds left, etc.",Component=C_Boolean)
	Options_Announcements(10) = (Caption="Player Joined/Left/Spectates/Changed Teams",Property=bShowPlayerEvents,Description="Shows select messages centered on the HUD.",Component=C_Boolean)
}
