// Developed 2011-2013 rejecht <rejecht at outlook dot com>

class UT2K4Tab_MidGameOptions extends MidGamePanel
	HideDropDown
	;

enum EComponent
{
	C_Boolean,
	C_List,
	C_Number_Integer,
	C_Number_Real,
	C_Range,
	C_Section,
	C_Ignore
};

var protected const array<string> Text_ClassName_Component; // The GUI component that maps to the EComponent value set in the option.

// - To map IndexTag to property name.

struct SComponent
{
	var int IndexTag;
	var name Property;
};

var array<SComponent> Group_Component;

struct SOption
{
	var name Property;
	var localized string Caption;
	var localized string Description;
	var EComponent Component;
};

var protected int Option_IndexTag;
var protected array<SOption> Option_Group;

// #

protected function Option_Append (int IndexTag, name Property)
{
	local int Index;

	Index = Group_Component.Length;

	Group_Component.Length = Group_Component.Length + 1;

	Group_Component[Index].IndexTag = IndexTag;
	Group_Component[Index].Property = Property;
}

protected function name Option_OutText_PropertyName (int IndexTag)
{
	local int Index;
	local int Count;

	Count = Group_Component.Length;

	for (Index = 0; Index < Count; ++Index)
	{
		if (Group_Component[Index].IndexTag == IndexTag)
		{
			return Group_Component[Index].Property;
		}
	}

	return '';
}

protected function Option_OnCreate (GUIMenuOption moNew, name Property)
{
	switch (Property)
	{
		default:
			Warn ("Unhandled: Property"@Property);
			break;
	}
}

protected function Option_OnChange (GUIMenuOption moChanged)
{
	switch (Option_OutText_PropertyName (moChanged.Tag))
	{
		default:
			Warn ("Unhandled: "@Option_OutText_PropertyName (moChanged.Tag));
			break;
	}
}

// #Initialized

event InternalOnChange (GUIComponent Sender)
{
	if (GUIMultiOptionList(Sender) != None)
	{
		Option_OnChange (GUIMultiOptionList(Sender).Get ());
	}
}

function ListOnCreateComponent (GUIMenuOption NewComp, GUIMultiOptionList Sender)
{
	NewComp.LabelJustification = TXTA_Left;
	NewComp.ComponentJustification = TXTA_Right;

	if (NewComp.IsA ('GUIListHeader'))
	{
		NewComp.StyleName = "NoBackground";
		NewComp.LabelStyleName = "TextLabel";
		NewComp.FontScale = FNS_Medium;
	}
}

protected function Option_Reset ()
{
	Option_IndexTag = 0;
	Option_Group.Length = 0;
}

// #

DefaultProperties
{
	// Components

	Text_ClassName_Component(0) = "XInterface.moCheckBox"
	Text_ClassName_Component(1) = "XInterface.moComboBox"
	Text_ClassName_Component(2) = "XInterface.moFloatEdit"
	Text_ClassName_Component(3) = "XInterface.moNumericEdit"
	Text_ClassName_Component(4) = "XInterface.moSlider"
	Text_ClassName_Component(5) = "XInterface.GUIListHeader"
}
