// Developed 2011-2013 rejecht <rejecht at outlook dot com>

class UT2K4Tab_PlayerLogin extends UT2K4Tab_PlayerLoginControls
    HideDropDown
    ;

event bool InternalOnPreDraw (Canvas C)
{
    local PlayerController PC;
    local GameReplicationInfo GRI;

    GRI = GetGRI ();

    if (GRI == None)
    {
        return false;
    }

    PC = PlayerOwner ();

    if (PC.PlayerReplicationInfo == None)
    {
        return false;
    }

    if (bInit)
    {
        InitGRI ();
    }

    if (bTeamGame)
    {
        if ( GRI.Teams[0] != None )
        {
            sb_Red.Caption = RedTeam@string(int(GRI.Teams[0].Score));
        }

        if ( GRI.Teams[1] != None )
            sb_Blue.Caption = BlueTeam@string(int(GRI.Teams[1].Score));

        if (PC.PlayerReplicationInfo.Team != None)
        {
            if (PC.PlayerReplicationInfo.Team.TeamIndex == 0)
            {
                sb_Red.HeaderBase = Texture'Display95';
                sb_Blue.HeaderBase = sb_blue.Default.headerbase;
            }
            else
            {
                sb_Blue.HeaderBase = Texture'Display95';
                sb_Red.HeaderBase = sb_blue.Default.headerbase;
            }
        }
    }

    SetButtonPositions (C);

    UpdatePlayerLists ();

    if
    (
        PC.IsInState ('GameEnded')
        ||
        (PC.MyHUD == None)
        ||
        PC.MyHUD.IsInCinematic ()
    )
    {
        DisableComponent (b_Spec);
    }
    else
    {
        EnableComponent (b_Spec);
    }

    return false;
}
